// thumbelina.c

#include "combo.h"  
//#include <math.h>

#define begin {
#define end   }



//==================================
// drawThumbelina
//
// Draws Thumbelina on the screen at position (x,y) using
// color c where c=0 means black, c=1 means white, c=2 means invert
void drawThumbelina(char x, char y, char c)
begin
	//draw head
	video_pt(x-1,y-2,c);
	video_pt(x,y-3,c);
	video_pt(x+1,y-2,c);
	video_pt(x,y-1,c);
		
	//draw arms
	video_pt(x-2,y,c);
	video_pt(x-1,y,c);
	video_pt(x,y,c);
	video_pt(x+1,y,c);
	video_pt(x+2,y,c);
	     
	//draw legs
	video_pt(x-2,y+4,c);
	video_pt(x-1,y+3,c);
	video_pt(x,y+2,c);
	video_pt(x,y+1,c);
	video_pt(x+1,y+3,c);
	video_pt(x+2,y+4,c);  
end      

//===========================================
// ThumbelinaMove
//
// Moves Thumbelina based on his current location and his position
// relative to the student.  To make things easier, Thumbelina can only
// move along a specific path and only changes directions at specific
// "decision" points.
void ThumbelinaMove(void)
begin
	//if Thumbelina is taking the stairs, use color inversion so stairs don't erase
	if (ThumbelinaY==61 && ThumbelinaX > 95) drawThumbelina(ThumbelinaX,ThumbelinaY,2);
	//otherwise, just erase him
	else drawThumbelina(ThumbelinaX,ThumbelinaY,0);
	
	//switch on Thumbelina's Y position
	switch(ThumbelinaY)
	begin 
		case(16)://on upper sidewalk
		begin
			switch(ThumbelinaX)
			begin
				case(6)://in top left corner
				begin
					//if student is also on upper sidewalk
					if (studentY<=ThumbelinaY+3)
					begin
						vy=1;//go down towards Phillips entrance
						vx=0;
					end
					// if student is on left sidewalk
					else if (studentX<=ThumbelinaX+3)
					begin
						vy=0;//go right along upper sidewalk
						vx=1;
					end
					else //otherwise continue around the corner
					begin
						vy++;
						vx++;
					end					
					break;
				end
				case(78)://at top of diagonal sidewalk (closed)
				begin
					//if student is on the right
					if (studentX > ThumbelinaX)
					begin
						vy=0;//go left along upper sidewalk
						vx=-1;
						/*if(timer%2==0)
						begin
							vy=0;//go left along upper sidewalk half the time
							vx=-1;
						end
						else
						begin
							vy=1;//down the diagonal half the time
							vx=-2;
						end*/
					end
					else //otherwise go right
					begin
						vy=0;
						vx=1;
					end
					break;
				end
				case(118)://at top right corner
				begin
					//if student also on upper sidewalk
					if (studentY<=ThumbelinaY+3)
					begin
						vy=1;//go down the sidewalk towards first floor stairs
						vx=0;
					end
					//if student on the rightmost sidewalk
					else if (studentX>=ThumbelinaX-3)
					begin
						vy=0;
						vx=-1;//go left along upper sidewalk
					end
					else //otherwise continue around corner
					begin
						vy++;
						vx--;
					end					
					break;
				end
				default: break;
			end
			break;
		end//on upper side walk
		/*case(47)://outside Phillips lounge/476 lab
		begin
			switch(ThumbelinaX)
			begin
				case(97)://outside lounge
				begin
					vy=1;
					vx=0;
					break;
				end
				default: break;
			end
			break;
		end*/
		case(52)://at bottom of diagonal sidewalk
		begin
			switch(ThumbelinaX)
			begin
				case(6)://bottom of diagonal
				begin
					//if student below Thumbelina
					if(studentY > ThumbelinaY)
					begin
						vy=-1;//go straight up sidewalk half the time
						vx=0;
						/*if(timer%2==0)
						begin
							vy=-1;//go straight up sidewalk half the time
							vx=0;
						end
						else
						begin
							vy=-1;//go up diagonal sidewalk half the time
							vx=2;
						end*/
					end
					//otherwise, go down sidewalk towards Phillips entrance
					else
					begin
						vy=1;
						vx=0;
					end
					break;
				end
				default: break;
			end
			break;
		end//at bottom of diagonal sidewalk
		case(61)://at stairs to first floor
		begin
			switch(ThumbelinaX)//at stairs to first floor
			begin
				case(97)://inside Phillips
				begin
					//if student is to the left
					if (studentX < ThumbelinaX)
					begin
						vy=0;
						vx=1;//go right (outside)
					end
					else//otherwise go left (inside)
					begin
						vy=1;
						vx=0;
					end
					break;
				end
				case(118)://outside Phillips
				begin
					//if student is on right sidewalk or above Thumbelina
					if (studentX>=ThumbelinaX-3 || studentY < ThumbelinaY)
					begin
						vy=0;//go left (inside)
						vx=-1;
					end
					else //otherwise go up right sidewalk
					begin
						vy=-1;
						vx=0;
					end					
					break;
				end
				default: break;
			end
			break;
		end//at stairs to first floor
		case(72)://in lower hallway
		begin
			switch(ThumbelinaX)
			begin
				case(6)://outside Phillips Entrance
				begin
					//if student in hallway
					if (studentY>=ThumbelinaY-3)
					begin
						vy=-1;//go up sidewalk
						vx=0;
					end
					else//otherwise go right (into Phillips)
					begin
						vy=0;
						vx=1;
					end
					break;
				end
				case(23)://outside Thumbelina's office
				begin
					//if student is to the right
					if (studentX > ThumbelinaX)
					begin
						vy=0;
						vx=-1;//go left
					end
					else//otherwise go right
					begin
						vy=0;
						vx=1;
					end
					break;
				end
				case(34)://outside Phillips 203
				begin
					//if student is to the right
					if (studentX > ThumbelinaX)
					begin
						vy=0;
						vx=-1;//go left
					end
					else//otherwise go right
					begin
						vy=0;
						vx=1;
					end
					break;
				end
				case(49)://outside random office
				begin
					//if student is to the right
					if (studentX > ThumbelinaX)
					begin
						vy=0;
						vx=-1;//go left
					end
					else//otherwise go right
					begin
						vy=0;
						vx=1;
					end
					break;
				end
				case(58)://outside second floor stairs
				begin
					//if student is to the right
					if (studentX > ThumbelinaX)
					begin
						vy=0;
						vx=-1;//go left
					end
					else//otherwise go right
					begin
						vy=0;
						vx=1;
					end
					break;
				end
				case(78)://outside Bernie's office
				begin
					//if student is to the right
					if (studentX > ThumbelinaX)
					begin
						vy=0;
						vx=-1;//go left
					end
					else//otherwise go right
					begin
						vy=0;
						vx=1;
					end
					break;
				end
				case(81)://outside Phillips 213
				begin
					//if student is to the right
					if (studentX > ThumbelinaX)
					begin
						vy=0;
						vx=-1;//go left
					end
					else//otherwise go right
					begin
						vy=0;
						vx=1;
					end
					break;
				end
				case(97)://at hallway intersection
				begin
					//if student is in lower hallway
					if (studentY>=ThumbelinaY-3)
					begin
						vy=-1;//go up toward stairs to first floor
						vx=0;
					end
					else//otherwise go left down hallway
					begin
						vy=0;
						vx=-1;
					end
					break;
				end
				/*case(110)://Phillips 219
				begin
					vy=0;
					vx=-1;
					break;
				end*/
				default: break;
			end
			break;
		end//in lower hallway
		default: break;
	
	end//switch(ThumbelinaY)
	
	ThumbelinaX = ThumbelinaX + vx;//increment X position by speed in X direction
	ThumbelinaY = ThumbelinaY + vy;//increment Y position by speed in Y direction
	
	//redraw Thumbelina at his new position
	if (ThumbelinaY==61 && ThumbelinaX > 95) drawThumbelina(ThumbelinaX,ThumbelinaY,2);
	else drawThumbelina(ThumbelinaX,ThumbelinaY,1);
end

//==================================
// drawStudent
//
// Draws student on the screen at position (x,y) using
// color c where c=0 means black, c=1 means white, c=2 means invert
void drawStudent(char x, char y, char c)
begin

	//draw head
	video_pt(x-1,y-2,c);
	video_pt(x-1,y-3,c);
	video_pt(x,y-3,c);
	video_pt(x+1,y-2,c);
	video_pt(x+1,y-3,c);
	video_pt(x,y-1,c);
	video_pt(x,y-2,c);
	
	//draw arms
	video_pt(x-2,y,c);
	video_pt(x-1,y,c);
	video_pt(x,y,c);
	video_pt(x+1,y,c);
	video_pt(x+2,y,c);
	     
	//draw legs
	video_pt(x-2,y+4,c);
	video_pt(x-1,y+3,c);
	video_pt(x,y+2,c);	
	video_pt(x,y+1,c);
	video_pt(x+1,y+3,c);
	video_pt(x+2,y+4,c);
end

//===========================================
// studentMove
//
// Moves student based on his current location, current surroundings
// and user button pushes.
void studentMove(void)
begin
	//invert (generally erase) student colors
	drawStudent(studentX,studentY,2);
	
	//switch on user button pushes
	//If user presses a directional button (up,down,left right)
	//check to see if the student's path is blocked in that direction.
	//If it is not (canMove=1) alter student's position accordingly.

	//canMove is calculated by creating an imaginary line in the direction the user
	//wants the student to move (a horizontal line above the student's head
	//when the user wants to move up for instance) and checks the color of the screen
	//at the line.  If any pixels are black, an object is in the student's path and
	//canMove is 0.  Otherwise the path is clear and canMove is 1. 
	switch(button)
	begin
		case(upButton):
		begin
			canMove = !video_set(studentX-2,studentY-4);
			canMove = canMove && !video_set(studentX-1,studentY-4);
			canMove = canMove && !video_set(studentX,studentY-4);
			canMove = canMove && !video_set(studentX+1,studentY-4);
			canMove = canMove && !video_set(studentX+2,studentY-4);

			studentY=studentY-canMove;
			canMove = 0;
			break;
		end
		case(downButton):
		begin
			canMove = !video_set(studentX-2,studentY+5);
 			canMove = canMove && !video_set(studentX-1,studentY+5);
 			canMove = canMove && !video_set(studentX,studentY+5);
 			canMove = canMove && !video_set(studentX+1,studentY+5);
 			canMove = canMove && !video_set(studentX+2,studentY+5);
 
 			studentY=studentY+canMove;
 			canMove=0; 
			break;
		end
		case(leftButton):
		begin
			canMove = (!video_set(studentX-3,studentY-3)); 
			canMove = canMove && (!video_set(studentX-3,studentY-2)); 
			canMove = canMove && (!video_set(studentX-3,studentY-1));
			canMove = canMove && (!video_set(studentX-3,studentY));
			canMove = canMove && (!video_set(studentX-3,studentY+1));
			canMove = canMove && (!video_set(studentX-3,studentY+2));
			canMove = canMove && (!video_set(studentX-3,studentY+3));
			canMove = canMove && (!video_set(studentX-3,studentY+4));
			canMove = canMove || (studentX >= 99 && studentX <=114 && studentY >= 60 && studentY <=62);
			
			studentX = studentX-canMove; 
			canMove=0;
			break;
		end
		case(rightButton):
		begin
			canMove = (!video_set(studentX+3,studentY-3));  
			canMove = canMove && (!video_set(studentX+3,studentY-1));
			canMove = canMove && (!video_set(studentX+3,studentY-1));
			canMove = canMove && (!video_set(studentX+3,studentY));
			canMove = canMove && (!video_set(studentX+3,studentY+1));
			canMove = canMove && (!video_set(studentX+3,studentY+2));
			canMove = canMove && (!video_set(studentX+3,studentY+3));
			canMove = canMove && (!video_set(studentX+3,studentY+4));
			canMove = canMove || (studentX >= 99 && studentX <=114 && studentY >= 60 && studentY <=62);
			
			studentX=studentX+canMove; 
			canMove=0;
			break;
		end
		//The following commented out section was used to allow the student to allow
		//the student to walk along the diagonal sidewalk.  It had to be taken out
		//due to memory restrictions.  It basically checked to see if the student was
		//in the diagonal sidewalk region.  Then checks to see if there is blockage in
		//two dirctions (down and left or up and right) leaving a little bit of room for
		//error since the sidewalk is thin.  Then moves the student accordingly.
		/*case(downLeftButton):
		begin
			if (studentX >=0 && studentX <=78 && studentY >=11 && studentY <=56) 
			begin
				//check down
				canMove = !video_set(studentX-2,studentY+5);
     				canMove = canMove && !video_set(studentX-1,studentY+5);
     				canMove = canMove && !video_set(studentX,studentY+5);
     				canMove = canMove && !video_set(studentX+1,studentY+5);
     				canMove = canMove && !video_set(studentX+2,studentY+5); 
     				
				//check left
     				canMove = canMove && (!video_set(studentX-3,studentY-2)); 
     				canMove = canMove && (!video_set(studentX-3,studentY-1));
     				canMove = canMove && (!video_set(studentX-3,studentY));
     				canMove = canMove && (!video_set(studentX-3,studentY+1));
     				canMove = canMove && (!video_set(studentX-3,studentY+2));
     				canMove = canMove && (!video_set(studentX-3,studentY+3));          			
     			
				studentY=studentY+canMove;
				studentX=studentX-2*canMove;
			end
			break;
		end
		case(upRightButton):
		begin
			if (studentX >=0 && studentX <=78 && studentY >=11 && studentY <=56)
			begin
				//check up
				canMove = !video_set(studentX-2,studentY-4);
				canMove = canMove && !video_set(studentX-1,studentY-4);
				canMove = canMove && !video_set(studentX,studentY-4);
				canMove = canMove && !video_set(studentX+1,studentY-4);
				canMove = canMove && !video_set(studentX+2,studentY-4);
				 
				//check right
				canMove = canMove && (!video_set(studentX+3,studentY-1));
				canMove = canMove && (!video_set(studentX+3,studentY-1));
				canMove = canMove && (!video_set(studentX+3,studentY));
				canMove = canMove && (!video_set(studentX+3,studentY+1));
				canMove = canMove && (!video_set(studentX+3,studentY+2));
				canMove = canMove && (!video_set(studentX+3,studentY+3));
				canMove = canMove || (studentX >= 99 && studentX <=114 && studentY >= 60 && studentY <=62);
			
			
				studentY=studentY-canMove;
				studentX=studentX+2*canMove;
			end
			break;
		end*/
		default: break;
	end
	drawStudent(studentX,studentY,2);
	button=0;	
end

//==================================
// ThumbelinaDir
// 
// Displays directions for Thumbelina Tag.
// When start button is pressed, the screen is erased in preparation
// for level initialization and play.
void ThumbelinaDir(void)
begin
	switch(drawingFrame)
	begin
		case(0):
		begin
		     	sprintf(screenString,"TASK 2:");
		     	video_putsmalls(4,15,screenString);
		     	
		     	sprintf(screenString,"CHOOSING A CONCENTRATION");
		     	video_putsmalls(4,25,screenString);
		     
		     	sprintf(screenString,"FIND THUMBELINA AND HAVE HIM");
		     	video_putsmalls(4,40,screenString); 
		     	
		     	drawThumbelina(113,65,1);
		     
		     	drawingFrame=1;
			break;
		end
		case(1):
		begin

			sprintf(screenString,"SIGN THE NECESSARY PAPERWORK");
		     	video_putsmalls(4,48,screenString);
		     
		     	sprintf(screenString,"USE THE ARROWS TO MOVE");
		     	video_putsmalls(4,63,screenString); 
		     
		     	sprintf(screenString,"PRESS START TO PAUSE GAME");
		     	video_putsmalls(4,71,screenString);
		
			drawingFrame=2;
			break;
		end
		case(2):
		begin
		   	if(button==startButton)
			begin
				video_putsmalls(4,15,blanks);
     		     		video_putsmalls(4,25,longBlanks);
     		     		video_putsmalls(4,40,longBlanks);
     		     		drawThumbelina(113,65,0); 
     		     
            			button=0;
				drawingFrame = 3;
			end
			break;
		end
		case(3):
		begin
		   	video_putsmalls(4,48,longBlanks);
     			video_putsmalls(4,63,longBlanks); 
     			video_putsmalls(4,71,longBlanks);  
     			drawingFrame=4;
     			sprintf(screenString,"Thumbelina Tag");
     		     	break;
		end
		case(4):
		begin
            		video_puts(18,3,screenString);
            		
            		levelState = Init;//set levelState to Init to initialize level
            		drawingFrame=0;
            		break;
		end
	end//switch
end



//==================================
// ThumbelinaInit
//
// Initializes level by drawing a map of Phillips and setting all
// relevent variables.
void ThumbelinaInit(void)
begin     
  	switch(drawingFrame)
  	begin
  		case(0):
  		begin

             	 
  			/*//draw small triangle of grass
               		video_line(11,22,11,44,1);
               		video_line(11,22,55,22,1);
               		video_line(11,44,55,22,1);
               
               		//draw large triangle of grass
               		video_line(11,56,89,56,1);
               		video_line(11,56,79,22,1);
               		video_line(79,56,79,22,1);*/
               
               		//diag sidewalk
               		video_line(11,22,11,66,1);
               		video_line(11,22,112,22,1);
               		video_line(11,56,89,56,1);
               		video_line(79,56,79,22,1);
			video_line(11,56,79,22,1);
                              
			//draw stairs
			video_line(101,67,125,67,1);
			video_line(102,57,102,66,1);
			video_line(105,57,105,66,1);
			video_line(108,57,108,66,1);
			video_line(111,57,111,66,1); 
			
			ThumbelinaX = 23;//start Thumbelina out in his office
		     	ThumbelinaY = 61;
		     	vy=1;//start him moving down (out of office)
		     	vx=0;
               		drawThumbelina(ThumbelinaX,ThumbelinaY,1);//draw him 
               
               		studentX = 5;//start student at upper left corner of sidewalk
               		studentY = 17;
               		drawStudent(studentX,studentY,1);//draw him
               
               		holdCountReset=38;
               		//sets holdCount in debounce to 38 so holding a directional button down
               		//will make the student move quickly
               		stopTime=0;
               		timer=0;
			time=0;
			totalCredits = 50;//total possible credits
              
              		drawingFrame=1;//set drawingFrame to 1 so rest of frame is drawn
              		break;
    		end
    		case(1):
    		begin
    			//draw upper hallway
    			video_line(11,44,55,22,1);//diag
               		//video_line(79,22,112,22,1); //top
			//video_line(79,22,79,55,1);  //left side
			video_line(112,22,112,56,1);//right side 
			video_line(80,38,90,38,1);  //left office
			video_line(90,39,90,42,1);
			video_line(90,52,90,67,1);
			video_line(101,38,111,38,1);//right office
			video_line(101,39,101,42,1);
			video_line(101,52,101,56,1);
			video_line(102,56,111,56,1);
               
    			//draw lower hallway
			//video_line(11,57,11,66,1); //walls
               		video_line(35,57,35,66,1);
               		video_line(63,57,63,66,1);
               		video_line(11,67,17,67,1); //doors      
			video_line(28,67,43,67,1);
			video_line(54,67,71,67,1);
			video_line(82,67,89,67,1);
			video_line(11,79,11,88,1); //walls
			video_line(52,79,52,88,1);
			video_line(63,79,63,88,1);
			video_line(96,79,96,88,1);
			video_line(11,78,27,78,1); //doors
			video_line(38,78,52,78,1);
			video_line(63,78,74,78,1);
			video_line(85,78,105,78,1);
			video_line(116,78,125,78,1);
               
			//draw stairs
			video_line(53,79,62,79,1);
			video_line(53,82,62,82,1);
			video_line(53,85,62,85,1);
			video_line(53,88,62,88,1);
         	
			drawingFrame=0;
			levelState=Game; //set level1State to Game to begin gameplay
			songState=bee;//set songState to bee so Flight of the Bumblebee is played
			noteIndex=1;
			break;
          	end        
	end
end

//======================================
// Thumbelina
//
// Controls game play.  Moves both Thumbelina and student when the game
// is not paused.  Then checks to see if the student has tagged Thumbelina.      
void Thumbelina(void)
begin
	//if start button is pressed, pause/unpause all movements and timer
	if(button==startButton)
	begin
		stopTime=stopTime^1;
		button=0;
	end
	//if unpaused
	if (stopTime==0)
	begin
     	//update the second clock
     	//if time exceeds 59 (frames), one second has passed
		if (++time>59)
		begin
			time=0;//reset time 
			timer++;//increment the timer
			sprintf(timerString,"%05d",timer);//make the timer into a string
			video_putsmalls(104,92,timerString);//and display it on the screen
		end

		//decrement number of credits earned by 1 every 5 seconds
		if (time==0 && timer%5 == 0 && totalCredits > 0) totalCredits--;
          
		//move Thumbelina every 6 frames
		if (drawingFrame==1) ThumbelinaMove();
		drawingFrame = (drawingFrame+1)%6;
          
		studentMove();//move student
          
		//if student is "close enough" to Thumbelina 
		if (abs(studentX-ThumbelinaX) < 10  && abs(studentY-ThumbelinaY) < 15) 
		begin
			credits=credits+totalCredits;//increment credits
            		sprintf(creditsString,"%03d",credits);//display credits
            		video_putsmalls(4,92,creditsString);
            		stopTime = 1;//stop the time
            		drawingFrame=0;
            		levelState = Check;
            		//set levelState to Check - displays screen saying Thumbelina "tagged"
		end  
	end       
end

//====================================
// ThumbelinaStateMachine
//
// Runs entire level from directions through gameplay to level complete.
// Ensures that all transistions are made properly.
void ThumbelinaStateMachine(void)
begin
	switch(levelState)
	begin
		case(Dir):
		begin
			ThumbelinaDir();
			break;
		end 
		case(Init):
		begin
			ThumbelinaInit(); 
			break;
		end
		case(Game):
		begin
			Thumbelina();
			break;
		end
		case(Check):
		begin
			//erase screen
            		switch(drawingFrame)
            		begin
            			case(0):
            			begin
            				video_line(11,22,11,66,0);
                         		video_line(11,22,112,22,0);
                         		video_line(11,56,89,56,0);
                         		video_line(79,56,79,22,0);
                         		video_line(11,56,79,22,0);
                         
                         		//draw stairs
                         		video_line(101,67,125,67,0);
                         		video_line(102,57,102,66,0);
                         		video_line(105,57,105,66,0);
                         		video_line(108,57,108,66,0);
                         		video_line(111,57,111,66,0); 
                         
                         		drawThumbelina(ThumbelinaX,ThumbelinaY,0); 
                         		drawStudent(studentX,studentY,0);
                        
                        		drawingFrame = 1;//set drawingFrame to 1 so rest of frame is drawn
                        		break;
              			end
              			case(1):
              			begin
              				//draw upper hallway
              				video_line(11,44,55,22,0);//diag
                         		//video_line(79,22,112,22,0); //top
                         		//video_line(79,22,79,55,0);  //left side
                         		video_line(112,22,112,56,0);//right side 
                         		video_line(80,38,90,38,0);  //left office
                         		video_line(90,39,90,42,0);
                         		video_line(90,52,90,67,0);
                         		video_line(101,38,111,38,0);//right office
                         		video_line(101,39,101,42,0);
                         		video_line(101,52,101,56,0);
                         		video_line(102,56,111,56,0);
                         
              				//draw lower hallway
                         		//video_line(11,57,11,66,0); //walls
                         		video_line(35,57,35,66,0);
                         		video_line(63,57,63,66,0);
                         		video_line(11,67,17,67,0); //doors      
                         		video_line(28,67,43,67,0);
                         		video_line(54,67,71,67,0);
                         		video_line(82,67,89,67,0);
                         		video_line(11,79,11,88,0); //walls
                         		video_line(52,79,52,88,0);
                         		video_line(63,79,63,88,0);
                         		video_line(96,79,96,88,0);
                         		video_line(11,78,27,78,0); //doors
                         		video_line(38,78,52,78,0);
                         		video_line(63,78,74,78,0);
                         		video_line(85,78,105,78,0);
                         		video_line(116,78,125,78,0);
                         
                         		//draw stairs
                         		video_line(53,79,62,79,0);
                         		video_line(53,82,62,82,0);
                         		video_line(53,85,62,85,0);
                         		video_line(53,88,62,88,0);           	
                         		drawingFrame=0;
                         		songState=none;//stop song play
                    			levelState = ShowCredits;
                    			break;
                    		end        
                	end//switch
                	break;
		end//Check
		case(ShowCredits):
		begin
			//display text saying that Thumbelina has been found
			switch(drawingFrame)
			begin
				case(0):
				begin
          		     		sprintf(screenString,"CONGRATULATIONS");
                       			video_putsmalls(4,20,screenString);
                       	
                       			sprintf(screenString,"YOU FOUND THUMBELINA");
                       			video_putsmalls(4,35,screenString);
                       	
                       			//sprintf(screenString,"YOUR NEW CONCENTRATION IS");
                       			//video_putsmalls(4,42,screenString);   
                       	
                       			drawingFrame=1;
                       			break;
                  		end
                  		case(1):
                  		begin
                       			sprintf(screenString,"PRESS START TO CONTINUE");
                       			video_putsmalls(4,80,screenString);  
                       	
                       			video_putsmalls(84,92,blanks);
                       	
                       			drawingFrame = 2;
                       	
                       			sprintf(screenTitle,"              ");
                  			break;
             			end
             			case(2):
             			begin
             		   		video_puts(18,3,screenTitle);
             		   		levelState=Ready;
             		   		drawingFrame = 0; 
             			end
			end//switch
			break;
		end//Check
		case(Ready):
		begin
			//When start is pressed, erase screen and tell game state machine
			//to move onto next level
		     	if (button==startButton)
		     	begin
				switch(drawingFrame)
     				begin
     					case(0):
     					begin
                            			video_putsmalls(4,20,longBlanks);
                            			video_putsmalls(4,35,longBlanks);
                            			video_putsmalls(4,42,longBlanks);   
                            	
                            			drawingFrame=1;
                            			break;
                       			end
                       			case(1):
                       			begin
                            			video_putsmalls(4,80,longBlanks); 
                            	
                            			drawingFrame = 0;
     					
     						yearState = trans;
                  		   		levelState=Dir;
                  		   		button=0; 
                  		   		break;
                  			end
                    		end//switch
          		end//start pressed
    			break;
    			
		end//Ready
		default: break;
	end//switch
end//state machine                


